addHook("PreThinkFrame", function()
	for p in players.iterate do


		if not p.mo then continue end

		local mo = p.mo

		if not mo.rotation then
			mo.rotation = {w=cos(mo.angle/2), x=0, y=0, z=sin(mo.angle/2)}
		end

		if mo.momx == 0 and mo.momy == 0 then
			continue
		end

		local slope = mo.standingslope
		local ground -- unit vector perpendicular to ground
		local v --unit vector along direction of motion
		if slope and slope.valid then
			ground = slope.normal
			v = VectNorm({ 
				x=mo.momx,
				y=mo.momy,
				z=FixedMul(VectMag({x=mo.momx, y=mo.momy,z=0}),FixedMul(cos(slope.xydirection-mo.angle),tan(slope.zangle)))
			})
		else
			ground = {x=0,y=0,z=FRACUNIT}
			v = VectNorm({x=mo.momx,y=mo.momy,z=0})
		end

		local rotational_axis = { -- cross product
			x=FixedMul(v.z,ground.y)-FixedMul(v.y,ground.z),
			y=FixedMul(v.x,ground.z)-FixedMul(v.z,ground.x),
			z=FixedMul(v.y,ground.x)-FixedMul(v.x,ground.y)
		}
		
		local r = mo.radius
		local velocity_magnitude = FixedSqrt(FixedMul(mo.momx,mo.momx) + FixedMul(mo.momy,mo.momy))

		local tau = 411775

		local rotation_radians = FixedDiv(velocity_magnitude, r) -- Snolf rotation this frame in radians
		local rotation_degrees = FixedDiv(FixedMul(360*FRACUNIT, rotation_radians),tau)
		local rotation_angle = FixedAngle(rotation_degrees)
		local half_rot = rotation_angle/2
		local sin_half_rot = sin(half_rot)

		local rotation_quaternion = {
			w=cos(half_rot),
			x=FixedMul(sin_half_rot,rotational_axis.x),
			y=FixedMul(sin_half_rot,rotational_axis.y),
			z=FixedMul(sin_half_rot,rotational_axis.z)
		}

		p.mo.rotation = QuatNorm(QuatMul(rotation_quaternion, p.mo.rotation))
	end
end)


