

rawset(_G, "QuatMul", function (p, q)
  return {
    w = FixedMul(p.w,q.w) - FixedMul(p.x,q.x) - FixedMul(p.y,q.y) - FixedMul(p.z,q.z),
    x = FixedMul(p.w,q.x) + FixedMul(p.x,q.w) + FixedMul(p.y,q.z) - FixedMul(p.z,q.y),
    y = FixedMul(p.w,q.y) + FixedMul(p.y,q.w) + FixedMul(p.z,q.x) - FixedMul(p.x,q.z),
    z = FixedMul(p.w,q.z) + FixedMul(p.z,q.w) + FixedMul(p.x,q.y) - FixedMul(p.y,q.x)
  }
end)

rawset(_G, "QuatMag", function (q)
  return FixedSqrt(FixedMul(q.w,q.w) + FixedMul(q.x,q.x) + FixedMul(q.y,q.y) + FixedMul(q.z,q.z))
end)

rawset(_G, "QuatNorm", function (q)
  local m = QuatMag(q)
  return {
    w = FixedDiv(q.w, m),
    x = FixedDiv(q.x, m),
    y = FixedDiv(q.y, m),
    z = FixedDiv(q.z, m)
  }
end)

rawset(_G, "QuatCon", function (q)
  return {
    w = q.w,
    x = -q.x,
    y = -q.y,
    z = -q.z
  }
end)

rawset(_G, "QuatRotate", function (v, q)
  return QuatMul(q,  QuatMul(v, QuatCon(q)))
end)


rawset(_G, "VectMag", function (q)
  if q.x == 0 and q.y == 0 and q.z == 0 then
    return 0
  end
  return FixedSqrt(FixedMul(q.x,q.x) + FixedMul(q.y,q.y) + FixedMul(q.z,q.z))
end)

rawset(_G, "VectNorm", function (q)
  local m = VectMag(q)
  if m == 0 then
    return {x=0,y=0,z=0}
  end
  return {
    x = FixedDiv(q.x, m),
    y = FixedDiv(q.y, m),
    z = FixedDiv(q.z, m)
  }
end)
